#ifndef __H_GAME__
#define __H_GAME__

#include <SDL2/SDL.h>
#include <stdbool.h>

#include "MousePointer.h"
#include "GameButton.h"


#define J_SCALE_FACTOR 5000



void quit (int rc);

typedef struct _Game Game;

struct _Game {
  SDL_Event event;
  SDL_Point mouse_delta;
  bool mouse_pressed;
  bool bg_colour_toggle;
  int done;
  SDL_Color background_colour;
  SDL_Window * window;
  SDL_Renderer * renderer;
  SDL_GameController * game_controller;
  MousePointer * mouse;
  GameButton * button;
};

Game * game_new ();
void game_process_events (Game * self);
void game_main_loop (Game * self);
void game_free (Game * self);
void game_draw (Game * self);

#endif
